UniversitySystemMvcApp/Controllers/CourseController.cs
using System.Collections.Generic;
using System.Web.Mvc;
using UniversitySystemMvcApp.Manager;
using UniversitySystemMvcApp.Models;
using UniversitySystemMvcApp.Models.ViewModels;

namespace UniversitySystemMvcApp.Controllers
{
    [Authorize]
    public class CourseController : Controller
    {
        public CourseManager CourseManager { get; set; }
        public DepartmentManager DepartmentManager { get; set; }
        public SemesterManager SemesterManager { get; set; }
        public CourseAssignManager CourseAssignManager { get; set; }
        public StudentManager StudentManager { get; set; }
        public EnrollCourseManager EnrollCourseManager { get; set; }

        public CourseController()
        {
            CourseManager = new CourseManager();
            DepartmentManager = new DepartmentManager();
            SemesterManager = new SemesterManager();
            CourseAssignManager = new CourseAssignManager();
            StudentManager = new StudentManager();
            EnrollCourseManager = new EnrollCourseManager();
        }
        [HttpGet]
        public ActionResult SaveCourse()
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            ViewBag.Semesters = SemesterManager.GetAllSemesterForDropDown();
            return View();
        }
        [HttpPost]
        public ActionResult SaveCourse(Course aCourse)
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            ViewBag.Semesters = SemesterManager.GetAllSemesterForDropDown();
            if (ModelState.IsValid)
            {
                ViewBag.Message = CourseManager.Save(aCourse);
            }
            else
            {
                
                ViewBag.Message = "Model State is Invalid";
            }        
            return View();
        }

        [HttpGet]
        public ActionResult ViewCourseStatistics()
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();           
            return View();
        }

        public JsonResult GetCourseViewsByDeptCode(string departmentCode)
        {
            List<CourseStatisticsViewModel> courses =
                CourseAssignManager.GetAllCoursesInfo().FindAll(x => x.DepartmentCode == departmentCode);
            return Json(courses);
        }

        [HttpGet]
        public ActionResult EnrollCourseToStudent()
        {
            ViewBag.StudentsReg = StudentManager.GetAllStudentsForDropdown();
            return View();
        }

        public JsonResult GetStudentByStudentId(int studentId)
        {
            Student student = StudentManager.GetAllStudents().Find(x=>x.Id==studentId);
            return Json(student);
        }
        
        [HttpPost]
        public ActionResult EnrollCourseToStudent(EnrollCourse enrollCourse)
        {
            ViewBag.StudentsReg = StudentManager.GetAllStudentsForDropdown();
            if (ModelState.IsValid)
            {
                ViewBag.Message = EnrollCourseManager.Save(enrollCourse);
            }
            else
            {
                ViewBag.Message = "Model State is Invalid";
            }
            return View();
        }

        [HttpGet]
        public ActionResult UnassignCourses()
        {
            return View();
        }

        [HttpPost]
        public ActionResult UnassignCourses(int? id)
        {
            ViewBag.Message = CourseAssignManager.UnassignCourses();
            return View();
        }
	}
}

UniversitySystemMvcApp/Controllers/RoomController.cs
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using UniversitySystemMvcApp.Manager;
using UniversitySystemMvcApp.Models;

namespace UniversitySystemMvcApp.Controllers
{
    [Authorize]
    public class RoomController : Controller
    {
        private RoomAllocateManager RoomAllocateManager { get; set; }
        private RoomManager RoomManager { get; set; }
        public DepartmentManager DepartmentManager { get; set; }
        public CourseManager CourseManager { get; set; }

        public RoomController()
        {
            RoomAllocateManager = new RoomAllocateManager();
            RoomManager = new RoomManager();
            DepartmentManager = new DepartmentManager();
            CourseManager = new CourseManager();
        }
        //
        // GET: /Room/
        [HttpGet]
        public ActionResult AllocateRoom()
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            ViewBag.Rooms = RoomManager.GetAllRoomsForDropDown();
            ViewBag.Days = GetAllDaysForDropDown();
            return View();
        }

        [HttpPost]
        public ActionResult AllocateRoom(RoomAllocate aRoomAllocate)
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            ViewBag.Rooms = RoomManager.GetAllRoomsForDropDown();
            ViewBag.Days = GetAllDaysForDropDown();
            if (ModelState.IsValid)
            {
                ViewBag.Message = RoomAllocateManager.Save(aRoomAllocate);
            }
            else
            {
                ViewBag.Message = "Model State is invalid";
            }
            return View();

        }

        public JsonResult GetCourseByDepartmentCode(string departmentCode)
        {
            List<SelectListItem> courseList =
                CourseManager.GetAllCoursesForDropDown().FindAll(x => x.Value == departmentCode);
            return Json(courseList);
        }

        private List<SelectListItem> GetAllDaysForDropDown()
        {
            List<SelectListItem> dayList = new List<SelectListItem>()
            {
                new SelectListItem(){Value = "Saturday",Text = "Saturday"},
                new SelectListItem(){Value = "Sunday",Text = "Sunday"},
                new SelectListItem(){Value = "Monday",Text = "Monday"},
                new SelectListItem(){ Value = "Tuesday",Text = "Tuesday"},
                new SelectListItem(){ Value = "Wednesday",Text = "Wednesday"},
                new SelectListItem(){Value = "Thursday",Text = "Thursday"},
                new SelectListItem(){ Value = "Friday",Text = "Friday"}
            };
            return dayList;
        }

        [HttpGet]
        public ActionResult ViewRoomSchedule()
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            //IEnumerable<Course> courses = CourseManager.GetAllCourses();
            //var courseList = courses.ToList().FindAll(c => c.DepartmentCode == departmentCode);
            return View();

        }
        
        public JsonResult GetClassScheduleByDepartment(string departmentCode)
        {
            List<Course> courses = CourseManager.GetAllCourses().FindAll(x=>x.DepartmentCode==departmentCode);

            List<object> clsSches = new List<object>();

            foreach (Course course in courses)
            {
                var scheduleInfo = RoomAllocateManager.GetAllClassScheduleViewsByDeptandCourse(departmentCode, course.Code);
                if (scheduleInfo == "")
                {
                    scheduleInfo = "Not sheduled yet";
                }


                var clsSch = new
                {
                    CourseCode = course.Code,
                    CourseName = course.Name,
                    ScheduleInfo = scheduleInfo
                };
                clsSches.Add(clsSch);
            }
            return Json(clsSches);
        }
        public JsonResult GetCoursesByDepartmentId(string departmentCode)
        {
            IEnumerable<Course> courses = CourseManager.GetAllCourses();
            var courseList = courses.ToList().FindAll(c => c.DepartmentCode == departmentCode);
            return Json(courseList);
        }

        [HttpGet]
        public ActionResult UnallocateRooms()
        {
            return View();
        }
        [HttpPost]
        public ActionResult UnallocateRooms(int? id)
        {
            ViewBag.Message = RoomAllocateManager.UnallocateAllRooms();
            return View();
        }
	}
}

UniversitySystemMvcApp/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta name="viewport" content="width=device-width" />
    @Scripts.Render("~/bundles/modernizr")
        @*@Styles.Render("~/Content/css")*@
    <link href="~/Content/bootstrap.css" rel="stylesheet" />
    <link href="~/Content/Site.css" rel="stylesheet" />
    <link href="~/Content/timepicki.css" rel="stylesheet" />
    <link href="~/Content/bootstrap-datepicker.min.css" rel="stylesheet" />
    <link href="~/Content/mobiscroll-2.13.2.full.min.css" rel="stylesheet" />
    <link href="~/Content/DataTables/css/jquery.dataTables.min.css" rel="stylesheet" />
    <script src='https://kit.fontawesome.com/a076d05399.js'></script>
    <script src="~/Scripts/jquery-3.5.1.js"></script>
    @*<script src="~/Scripts/bootstrap.js"></script>*@
    <script src="~/Scripts/bootstrap.bundle.js"></script>
    <script src="~/Scripts/jquery.validate.min.js"></script>
    <script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
    <script src="~/Scripts/DataTables/jquery.dataTables.min.js"></script>
    <script>
        $(document).ready(function () {
            $('#departments').DataTable();
        });
    </script>
    @*<script>
            $(document).ready(function () {
                $('#ViewCourseId').DataTable();
            });
        </script>*@
</head>
<body style="background-color: black; margin-bottom: 0px;">
    @*darkslategray*@
    <nav class="navbar fixed-top navbar-expand-lg navbar-dark bg-dark" style="margin-top: 0px">
        <a class="navbar-brand" style="color: whitesmoke; font-weight: bold;" href="#">UNIVERSITY SYSTEM</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarColor02" aria-controls="navbarColor02" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarColor02">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item active">
                    <a style="color: whitesmoke; font-weight: bold;" class="btn btn-light text-dark" id="btnGroupDrop2" type="button" href="~/Home/Index">
                        <svg width="1em" height="1em" viewBox="0 0 16 16" class="" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                            <path fill-rule="evenodd" d="M8 3.293l6 6V13.5a1.5 1.5 0 0 1-1.5 1.5h-9A1.5 1.5 0 0 1 2 13.5V9.293l6-6zm5-.793V6l-2-2V2.5a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5z" />
                            <path fill-rule="evenodd" d="M7.293 1.5a1 1 0 0 1 1.414 0l6.647 6.646a.5.5 0 0 1-.708.708L8 2.207 1.354 8.854a.5.5 0 1 1-.708-.708L7.293 1.5z" />
                        </svg>
                        
                        <span class="sr-only">(current)</span>
                    </a>
                </li>
                &nbsp;
                <li class="nav-item dropdown">
                    <button style="color: whitesmoke; font-weight: bold;" class="dropdown-toggle btn btn-primary" type="button" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Department</button>
                    <div class="dropdown-menu">
                        @Html.ActionLink("Save Department", "SaveDepartment", "Department", null, new { @class = "dropdown-item btn text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("View All Departments", "ViewAllDepartments", "Department", null, new { @class = "dropdown-item btn text-primary" })

                    </div>
                </li> &nbsp;
                <li class="nav-item dropdown">
                    <button style="color: whitesmoke; font-weight: bold;" class="dropdown-toggle btn btn-primary" type="button" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Course</button>
                    <div class="dropdown-menu">
                        @Html.ActionLink("Save Course", "SaveCourse", "Course", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("View Course Statistics", "ViewCourseStatistics", "Course", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("Un-assign Courses", "UnassignCourses", "Course", null, new { @class = "dropdown-item text-primary" })

                    </div>
                </li> &nbsp;
                <li class="nav-item dropdown">
                    <button style="color: whitesmoke; font-weight: bold;" class="dropdown-toggle btn btn-primary" type="button" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Teacher</button>
                    <div class="dropdown-menu">
                        @Html.ActionLink("Save Teacher", "SaveTeacher", "Teacher", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("Course Assign To a Teacher", "CourseAssignToTeacher", "Teacher", null, new { @class = "dropdown-item text-primary" })

                    </div>
                </li> &nbsp;
                <li class="nav-item dropdown">
                    <button style="color: whitesmoke; font-weight: bold;" class="dropdown-toggle btn btn-primary" type="button" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Student</button>
                    <div class="dropdown-menu">
                        @Html.ActionLink("Register Student", "SaveStudent", "Student", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("Student Result Update", "SaveResult", "Student", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("View Student Result", "ViewStudentResult", "Student", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("Enroll Course To Student", "EnrollCourseToStudent", "Course", null, new { @class = "dropdown-item text-primary" })

                    </div>
                </li> &nbsp;
                <li class="nav-item dropdown">
                    <button style="color: whitesmoke; font-weight: bold;" class="dropdown-toggle btn btn-primary" type="button" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Classroom</button>
                    <div class="dropdown-menu">
                        @Html.ActionLink("Assign a Room", "AllocateRoom", "Room", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("View Schedules", "ViewRoomSchedule", "Room", null, new { @class = "dropdown-item text-primary" })
                        <div class="dropdown-divider"></div>
                        @Html.ActionLink("Reset Room Schedule", "UnallocateRooms", "Room", null, new { @class = "dropdown-item text-primary" })


                    </div>
                </li>
            </ul>
            
                @Html.Partial("_LoginPartial")
                @*<button class="btn btn-secondary my-2 my-sm-0 " type="submit"><i class='fas fa-user-plus' style="color: azure"></i> <b style="color: azure">Login</b> </button>
                    <button class="btn btn-secondary my-2 my-sm-0 " type="submit"><i class="fas fa-sign-in-alt" style="color: azure"></i> <b style="color: azure">Register</b></button>*@
            

        </div>
    </nav>


    <div class="container body-content" style="margin-bottom:5px">
        @RenderBody()
    </div>
    <div class="navbar fixed-bottom navbar-dark bg-dark">
        <div align="center" style="color: whitesmoke; font-weight: bold">&copy; @DateTime.Now.Year Online Course & Result Management System</div>
    </div>
    
    
   
</body>
</html>

UniversitySystemMvcApp/Views/Shared/_LayoutOr.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - My ASP.NET Application</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")

</head>
<body>
    <div class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                @Html.ActionLink("Application name", "Index", "Home", new { area = "" }, new { @class = "navbar-brand" })
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li>@Html.ActionLink("Home", "Index", "Home")</li>
                    <li>@Html.ActionLink("About", "About", "Home")</li>
                    <li>@Html.ActionLink("Contact", "Contact", "Home")</li>
                </ul>
                @Html.Partial("_LoginPartial")
            </div>
        </div>
    </div>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; @DateTime.Now.Year - My ASP.NET Application</p>
        </footer>
    </div>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap")
    @RenderSection("scripts", required: false)
</body>
</html>